import { Controller } from "starspot-core";
import JSONAPI from "./json-api";
export default class ResourceController extends Controller {
    index(params: Controller.Parameters): Promise<JSONAPI.DataDocument>;
    create(params: Controller.Parameters): Promise<JSONAPI.DataDocument>;
    update(params: Controller.Parameters): Promise<JSONAPI.DataDocument>;
    invokeCallback(event: string, ...args: any[]): Promise<void>;
    private processRequest(params);
}
export declare function after(event: string): (proto: ResourceController, method: string) => void;
